# Copyright 2008-2009  Segher Boessenkool  <segher@kernel.crashing.org>
# This code is licensed to you under the terms of the GNU GPL, version 2;
# see file COPYING or http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt


	.extern InitBATS
	.globl _start
_start:

	# Disable interrupts, enable FP.
	mfmsr 3 ; rlwinm 3,3,0,17,15 ; ori 3,3,0x2000 ; mtmsr 3 ; isync

	# Setup stack.
	lis 1,_stack_top@ha ; addi 1,1,_stack_top@l ; li 0,0 ; stwu 0,-64(1)

	# Clear BSS.
	lis 3,__bss_start@ha ; addi 3,3,__bss_start@l
	li 4,0
	lis 5,__bss_end@ha ; addi 5,5,__bss_end@l ; sub 5,5,3
	bl memset
	#wtfstart
 

__configBATS:

        # HID0 = 00110c64:

        # bus checkstops off, sleep modes off,

        # caches off, caches invalidate,

        # store gathering off, enable data cache

        # flush assist, enable branch target cache,

        # enable branch history table

        lis             3,0x0011

        ori             3,3,0x0c64

        mtspr   1008,3 #HID0

        isync

        

        mfmsr   4

        ori             4,4,0x00002000    # MSR = 00002000 (FP on)

        mtmsr   4

        

        ori             3,3,0xc000    # d-cache & i-cache enable

        mtspr   1008,3 #HID0

        isync

        lis             3,0x8200               #bits set: H4A(HID4 access), SBE(2nd BAT enabled)

        mtspr   1011,3 #HID4

        isync

 
 
        # set [DI]BAT0 for 256MB@80000000,

        # real 00000000, WIMG=0000, R/W

        li              3,2

        lis             4,0x8000

        ori             4,4,0x1fff

        mtspr   529,3 #IBAT0L

        mtspr   528,4 #IBAT0U

        mtspr   537,3 #DBAT0L

        mtspr   536,4 #DBAT0U

        isync


        # set [DI]BAT4 for 256MB@90000000,

        # real 10000000, WIMG=0000, R/W

        addis   3,3,0x1000

        addis   4,4,0x1000

        mtspr   561,3 #IBAT4L

        mtspr   560,4 #IBAT4U

        mtspr   569,3 #DBAT4L

        mtspr   568,4 #DBAT4U

        isync

        

        # set DBAT1 for 256MB@c0000000,

        # real 00000000, WIMG=0101, R/W

        li              3,0x2a

        lis             4,0xc000

        ori             4,4,0x1fff

        mtspr   539,3 #DBAT1L

        mtspr   538,4 #DBAT1U

        isync


        # set DBAT5 for 256MB@d0000000,

        # real 10000000, WIMG=0101, R/W

        addis   3,3,0x1000

        addis   4,4,0x1000

        mtspr   571,3 #DBAT5L

        mtspr   570,4 #DBAT5U

        isync
		
        # clear all BATs

        li              0,0

        mtspr        532,0; mtspr        534,0               # IBAT2...3

        mtspr        540,0; mtspr        542,0               # DBAT2...3

        mtspr        564,0; mtspr        566,0               # IBAT6...7

        mtspr        572,0; mtspr        574,0               # DBAT6...7

        isync

 
        # clear all SRs

        lis             0,0x8000

        mtsr    0,0; mtsr      1,0; mtsr      2,0; mtsr      3,0; mtsr      4,0; mtsr      5,0; mtsr      6,0

        mtsr    7,0; mtsr      8,0; mtsr      9,0; mtsr      10,0; mtsr     11,0; mtsr     12,0; mtsr     13,0

        mtsr    14,0; mtsr     15,0

        isync
 
         mfmsr   3

         ori             3,3,0x00000030#MSR_DR|MSR_IR

         mtsrr1  3

         mflr    3

         mtsrr0  3
	#wtfend
	
	# Go!
	bl maino

	# If it returns, hang.  Shouldn't happen.
	b .
